package cn.x47.service;


import cn.x47.handle.RIPPacketDecoder;
import cn.x47.handle.RIPServerHandler;
import io.netty.bootstrap.Bootstrap;
import io.netty.channel.*;
import io.netty.channel.nio.NioEventLoopGroup;
import io.netty.channel.socket.DatagramChannel;
import io.netty.channel.socket.nio.NioDatagramChannel;

public class RIPServer {

    public void start() throws InterruptedException {
        NioEventLoopGroup group = new NioEventLoopGroup();
        try {
            Bootstrap b = new Bootstrap();
            b.group(group)
                    .channel(NioDatagramChannel.class)
                    .option(ChannelOption.SO_BROADCAST, true)
                    .handler(new ChannelInitializer<DatagramChannel>() {
                        @Override
                        protected void initChannel(DatagramChannel ch) throws Exception {
                            ch.pipeline().addLast(new RIPPacketDecoder(), new RIPServerHandler());
                        }
                    });

            ChannelFuture future = b.bind(520).sync();
            future.channel().closeFuture().await();
        } finally {
            group.shutdownGracefully();
        }
    }
}
